extends Node

signal connection_changed

var connection: Node

func stuff():
    name = "Remote"

    var game := Node.new()
    game.set_script(load("./game.gd"))
    game.name = "Game"
    add_child(game)

    var peer := NetworkedMultiplayerENet.new()
    peer.connect("connection_failed", self, "emit_signal", ["connection_changed", false])
    peer.connect("connection_succeeded", self, "emit_signal", ["connection_changed", true])
    peer.connect("server_disconnected", self, "server_disconnected")
    if peer.create_client(OS.get_environment("target"), 4321) != OK:
        print("create_client failed")

    get_tree().network_peer = peer
    if yield(self, "connection_changed"):
        connection = Node.new()
        connection.set_script(load("connection.gd"))
        connection.name = str(get_tree().get_network_unique_id())
        print("our connection name is ", connection.name)
        add_child(connection)
    else:
        print("fail")

    var username = OS.get_environment("username")
    var password = OS.get_environment("password")

    connection.rpc_id(1, "register", username, password, "")
    yield(connection, "registered")

    connection.rpc_id(1, "login", username, password)
    if yield(connection, "login"):
        print("logged in")
    else:
        print("Cannot log in")

    connection.rpc_id(1, "join_game")

    connection.rpc_id(1, "get_friends")
    var friends = yield(connection, "friendlist")
    print(friends)

func server_disconnected():
    get_tree().quit(1)
